diff -ru nginx-0.5.35/src/http/ngx_http_variables.c nginx-0.5.35-patched/src/http/ngx_http_variables.c
--- nginx-0.5.35/src/http/ngx_http_variables.c	2007-12-12 08:57:36.000000000 -0800
+++ nginx-0.5.35-patched/src/http/ngx_http_variables.c	2008-01-18 10:50:40.000000000 -0800
@@ -673,30 +673,32 @@
             i = 0;
         }
 
-        for (n = 0; n + prefix < var->len && n < header[i].key.len; n++) {
-            ch = header[i].key.data[n];
-
-            if (ch >= 'A' && ch <= 'Z') {
-                ch |= 0x20;
-
-            } else if (ch == '-') {
-                ch = '_';
+        if (var->len - prefix == header[i].key.len) {
+            for (n = 0; n < header[i].key.len; n++) {
+                ch = header[i].key.data[n];
+
+                if (ch >= 'A' && ch <= 'Z') {
+                    ch |= 0x20;
+
+                } else if (ch == '-') {
+                    ch = '_';
+                }
+
+                if (var->data[n + prefix] != ch) {
+                    break;
+                }
             }
 
-            if (var->data[n + prefix] != ch) {
-                break;
-            }
-        }
+            if (n == header[i].key.len) {
+                v->len = header[i].value.len;
+                v->valid = 1;
+                v->no_cacheable = 0;
+                v->not_found = 0;
+                v->data = header[i].value.data;
 
-        if (n + prefix == var->len && n == header[i].key.len) {
-            v->len = header[i].value.len;
-            v->valid = 1;
-            v->no_cacheable = 0;
-            v->not_found = 0;
-            v->data = header[i].value.data;
-
-            return NGX_OK;
-        }
+                return NGX_OK;
+            }
+        }      
     }
 
     v->not_found = 1;